//Правая часть дифференциального уравнения.
function y=f(x,t)
y=sin(x*t)
endfunction
//Начальное условие
function y=fi(x)
y=exp(0.15*x)
endfunction
//Условие на левой границе
function y=myu(t)
y=1
endfunction
//Условие на правой границе
function y=nyu(x)
y=2.117
endfunction
function [u,x,t]=parabol(N,K,L,T,a)
//Функция решения параболического уравнения методом сеток с
//помощью явной разностной схемы. N - количество участков,
//на которые разбивается интервал по х (0,L); K - количество
//участков, на которые разбивается интервал по t (0,T); a -
//параметр дифференциального уравнения теплопроводности,
//Функция возвращает матрицу решений u и вектора x, t
//Вычисляем шаг по х
h=L/N;
//Вычисляем шаг по t
delta=T/K;
//Формируем массив x и первый столбец матрицы решений U 
//из начального условия
for i=1:N+1
x(i)=(i-1)*h;
u(i,1)=fi(x(i));
end
//Формируем массив t, первую и последнюю строку 
//матрицы решений
//U из граничных условий
for j=1:K+1
t(j)=(j-1)*delta;
u(1,j)=myu(t(j));
u(N+1,j)=nyu(t(j));
end
gam=a^2*delta/h^2;
//Формируем матрицу решений u с помощью явной разностной схемы
//(12.9)
for j=1:K
for i=2:N
u(i,j+1)=gam*u(i-1,j)+(1-2*gam)*u(i,j)+gam*u(i+1,j)+delta*f(x(i),t(j));
end
end
end
[U,X,T]=parabol(50,200,5,3,0.4);
surf(X,T,U');
title('Параболическое уравнение');
xlabel('X');
ylabel('T');
